%global opt %(test -x %{_bindir}/ocamlopt && echo 1 || echo 0)
%global debug_package %{nil}

Name:           ocaml-zarith
Version:        1.1
Release:        3%{?dist}
Summary:        OCaml interface to GMP

# The license has a static linking exception
License:        LGPLv2 with exceptions
URL:            http://forge.ocamlcore.org/projects/zarith
Source0:        http://forge.ocamlcore.org/frs/download.php/835/zarith-%{version}.tgz

BuildRequires:  gmp-devel
BuildRequires:  ocaml
BuildRequires:  ocaml-findlib-devel
BuildRequires:  ocaml-ocamldoc
BuildRequires:  perl

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

#ExclusiveArch:  %{ocaml_arches}

%description
This library implements arithmetic and logical operations over
arbitrary-precision integers.  

The module is simply named "Z".  Its interface is similar to that of the
Int32, Int64 and Nativeint modules from the OCaml standard library, with
some additional functions.  See the file z.mlip for documentation.

The implementation uses GMP (the GNU Multiple Precision arithmetic
library) to compute over big integers.  However, small integers are
represented as unboxed Caml integers, to save space and improve
performance.  Big integers are allocated in the Caml heap, bypassing
GMP's memory management and achieving better GC behavior than e.g. the
MLGMP library.  Computations on small integers use a special, faster
path (coded in assembly for some platforms and functions) eschewing
calls to GMP, while computations on large integers use the low-level
MPN functions from GMP.

Arbitrary-precision integers can be compared correctly using OCaml's
polymorphic comparison operators (=, <, >, etc.).

Additional features include:
- a module Q for rationals, built on top of Z (see q.mli)
- a compatibility layer Big_int_Z that implements the same API as Big_int,
  but uses Z internally

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n zarith-%{version}

%build
# This is NOT an autoconf-generated configure script; %%configure doesn't work
CC="gcc -Wa,--noexecstack" CFLAGS="%{optflags}" ./configure
# %%{?_smp_mflags} is not safe; same action performed by multiple CPUs
make

%install
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs
make install INSTALLDIR=%{buildroot}%{_libdir}/ocaml
strip %{buildroot}%{_libdir}/ocaml/stublibs/dll*.so
strip %{buildroot}%{_libdir}/ocaml/zarith/*.cmxs

%check
# bitest takes a very long time to run; enable it with caution.
export LD_LIBRARY_PATH=$PWD
make tests
./test
./test.b

%files
%doc LICENSE Changes
%{_libdir}/ocaml/zarith/
%if %opt
%exclude %{_libdir}/ocaml/zarith/*.a
%exclude %{_libdir}/ocaml/zarith/*.cmxa
%endif
%exclude %{_libdir}/ocaml/zarith/*.mli
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner

%files devel
%doc README
%if %opt
%{_libdir}/ocaml/zarith/*.a
%{_libdir}/ocaml/zarith/*.cmxa
%endif
%{_libdir}/ocaml/zarith/*.mli

%changelog
* Thu Dec 13 2012 Jerry James <loganjerry@gmail.com> - 1.1-3
- Rebuild for OCaml 4.00.1

* Wed Oct 31 2012 Jerry James <loganjerry@gmail.com> - 1.1-2
- The -devel subpackage Requires need %%{?_isa}
- Try a different approach to keep the execstack flag off

* Fri Oct 26 2012 Jerry James <loganjerry@gmail.com> - 1.1-1
- Initial RPM
